config() {
  NEW="$1"
  OLD="`dirname $NEW`/`basename $NEW .new`"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "`cat $OLD | md5sum`" = "`cat $NEW | md5sum`" ]; then # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.openldap.new

config etc/openldap/slapd.conf.new
config etc/openldap/slapd.ldif.new
config etc/default/slapd.new
( cd usr/lib ; rm -rf libslapi-2.4.so.2 )
( cd usr/lib ; ln -sf libslapi-2.4.so.2.10.5 libslapi-2.4.so.2 )
( cd usr/lib ; rm -rf libslapi.so )
( cd usr/lib ; ln -sf libslapi-2.4.so.2.10.5 libslapi.so )
( cd usr/libexec/openldap ; rm -rf accesslog-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf accesslog-2.4.so.2.10.5 accesslog-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf accesslog.so )
( cd usr/libexec/openldap ; ln -sf accesslog-2.4.so.2.10.5 accesslog.so )
( cd usr/libexec/openldap ; rm -rf auditlog-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf auditlog-2.4.so.2.10.5 auditlog-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf auditlog.so )
( cd usr/libexec/openldap ; ln -sf auditlog-2.4.so.2.10.5 auditlog.so )
( cd usr/libexec/openldap ; rm -rf back_dnssrv-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_dnssrv-2.4.so.2.10.5 back_dnssrv-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_dnssrv.so )
( cd usr/libexec/openldap ; ln -sf back_dnssrv-2.4.so.2.10.5 back_dnssrv.so )
( cd usr/libexec/openldap ; rm -rf back_ldap-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_ldap-2.4.so.2.10.5 back_ldap-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_ldap.so )
( cd usr/libexec/openldap ; ln -sf back_ldap-2.4.so.2.10.5 back_ldap.so )
( cd usr/libexec/openldap ; rm -rf back_meta-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_meta-2.4.so.2.10.5 back_meta-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_meta.so )
( cd usr/libexec/openldap ; ln -sf back_meta-2.4.so.2.10.5 back_meta.so )
( cd usr/libexec/openldap ; rm -rf back_null-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_null-2.4.so.2.10.5 back_null-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_null.so )
( cd usr/libexec/openldap ; ln -sf back_null-2.4.so.2.10.5 back_null.so )
( cd usr/libexec/openldap ; rm -rf back_passwd-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_passwd-2.4.so.2.10.5 back_passwd-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_passwd.so )
( cd usr/libexec/openldap ; ln -sf back_passwd-2.4.so.2.10.5 back_passwd.so )
( cd usr/libexec/openldap ; rm -rf back_relay-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_relay-2.4.so.2.10.5 back_relay-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_relay.so )
( cd usr/libexec/openldap ; ln -sf back_relay-2.4.so.2.10.5 back_relay.so )
( cd usr/libexec/openldap ; rm -rf back_shell-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_shell-2.4.so.2.10.5 back_shell-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_shell.so )
( cd usr/libexec/openldap ; ln -sf back_shell-2.4.so.2.10.5 back_shell.so )
( cd usr/libexec/openldap ; rm -rf back_sock-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_sock-2.4.so.2.10.5 back_sock-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_sock.so )
( cd usr/libexec/openldap ; ln -sf back_sock-2.4.so.2.10.5 back_sock.so )
( cd usr/libexec/openldap ; rm -rf back_sql-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf back_sql-2.4.so.2.10.5 back_sql-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf back_sql.so )
( cd usr/libexec/openldap ; ln -sf back_sql-2.4.so.2.10.5 back_sql.so )
( cd usr/libexec/openldap ; rm -rf collect-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf collect-2.4.so.2.10.5 collect-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf collect.so )
( cd usr/libexec/openldap ; ln -sf collect-2.4.so.2.10.5 collect.so )
( cd usr/libexec/openldap ; rm -rf constraint-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf constraint-2.4.so.2.10.5 constraint-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf constraint.so )
( cd usr/libexec/openldap ; ln -sf constraint-2.4.so.2.10.5 constraint.so )
( cd usr/libexec/openldap ; rm -rf dds-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf dds-2.4.so.2.10.5 dds-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf dds.so )
( cd usr/libexec/openldap ; ln -sf dds-2.4.so.2.10.5 dds.so )
( cd usr/libexec/openldap ; rm -rf deref-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf deref-2.4.so.2.10.5 deref-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf deref.so )
( cd usr/libexec/openldap ; ln -sf deref-2.4.so.2.10.5 deref.so )
( cd usr/libexec/openldap ; rm -rf dyngroup-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf dyngroup-2.4.so.2.10.5 dyngroup-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf dyngroup.so )
( cd usr/libexec/openldap ; ln -sf dyngroup-2.4.so.2.10.5 dyngroup.so )
( cd usr/libexec/openldap ; rm -rf dynlist-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf dynlist-2.4.so.2.10.5 dynlist-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf dynlist.so )
( cd usr/libexec/openldap ; ln -sf dynlist-2.4.so.2.10.5 dynlist.so )
( cd usr/libexec/openldap ; rm -rf memberof-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf memberof-2.4.so.2.10.5 memberof-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf memberof.so )
( cd usr/libexec/openldap ; ln -sf memberof-2.4.so.2.10.5 memberof.so )
( cd usr/libexec/openldap ; rm -rf pcache-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf pcache-2.4.so.2.10.5 pcache-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf pcache.so )
( cd usr/libexec/openldap ; ln -sf pcache-2.4.so.2.10.5 pcache.so )
( cd usr/libexec/openldap ; rm -rf ppolicy-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf ppolicy-2.4.so.2.10.5 ppolicy-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf ppolicy.so )
( cd usr/libexec/openldap ; ln -sf ppolicy-2.4.so.2.10.5 ppolicy.so )
( cd usr/libexec/openldap ; rm -rf refint-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf refint-2.4.so.2.10.5 refint-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf refint.so )
( cd usr/libexec/openldap ; ln -sf refint-2.4.so.2.10.5 refint.so )
( cd usr/libexec/openldap ; rm -rf retcode-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf retcode-2.4.so.2.10.5 retcode-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf retcode.so )
( cd usr/libexec/openldap ; ln -sf retcode-2.4.so.2.10.5 retcode.so )
( cd usr/libexec/openldap ; rm -rf rwm-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf rwm-2.4.so.2.10.5 rwm-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf rwm.so )
( cd usr/libexec/openldap ; ln -sf rwm-2.4.so.2.10.5 rwm.so )
( cd usr/libexec/openldap ; rm -rf seqmod-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf seqmod-2.4.so.2.10.5 seqmod-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf seqmod.so )
( cd usr/libexec/openldap ; ln -sf seqmod-2.4.so.2.10.5 seqmod.so )
( cd usr/libexec/openldap ; rm -rf sssvlv-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf sssvlv-2.4.so.2.10.5 sssvlv-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf sssvlv.so )
( cd usr/libexec/openldap ; ln -sf sssvlv-2.4.so.2.10.5 sssvlv.so )
( cd usr/libexec/openldap ; rm -rf syncprov-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf syncprov-2.4.so.2.10.5 syncprov-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf syncprov.so )
( cd usr/libexec/openldap ; ln -sf syncprov-2.4.so.2.10.5 syncprov.so )
( cd usr/libexec/openldap ; rm -rf translucent-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf translucent-2.4.so.2.10.5 translucent-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf translucent.so )
( cd usr/libexec/openldap ; ln -sf translucent-2.4.so.2.10.5 translucent.so )
( cd usr/libexec/openldap ; rm -rf unique-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf unique-2.4.so.2.10.5 unique-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf unique.so )
( cd usr/libexec/openldap ; ln -sf unique-2.4.so.2.10.5 unique.so )
( cd usr/libexec/openldap ; rm -rf valsort-2.4.so.2 )
( cd usr/libexec/openldap ; ln -sf valsort-2.4.so.2.10.5 valsort-2.4.so.2 )
( cd usr/libexec/openldap ; rm -rf valsort.so )
( cd usr/libexec/openldap ; ln -sf valsort-2.4.so.2.10.5 valsort.so )
( cd usr/man/man5 ; rm -rf slapd-hdb.5.gz )
( cd usr/man/man5 ; ln -sf slapd-bdb.5.gz slapd-hdb.5.gz )
( cd usr/man/man5 ; rm -rf slapo-sock.5.gz )
( cd usr/man/man5 ; ln -sf slapd-sock.5.gz slapo-sock.5.gz )
( cd usr/sbin ; rm -rf slapacl )
( cd usr/sbin ; ln -sf ../libexec/slapd slapacl )
( cd usr/sbin ; rm -rf slapadd )
( cd usr/sbin ; ln -sf ../libexec/slapd slapadd )
( cd usr/sbin ; rm -rf slapauth )
( cd usr/sbin ; ln -sf ../libexec/slapd slapauth )
( cd usr/sbin ; rm -rf slapcat )
( cd usr/sbin ; ln -sf ../libexec/slapd slapcat )
( cd usr/sbin ; rm -rf slapd )
( cd usr/sbin ; ln -sf ../libexec/slapd slapd )
( cd usr/sbin ; rm -rf slapdn )
( cd usr/sbin ; ln -sf ../libexec/slapd slapdn )
( cd usr/sbin ; rm -rf slapindex )
( cd usr/sbin ; ln -sf ../libexec/slapd slapindex )
( cd usr/sbin ; rm -rf slappasswd )
( cd usr/sbin ; ln -sf ../libexec/slapd slappasswd )
( cd usr/sbin ; rm -rf slapschema )
( cd usr/sbin ; ln -sf ../libexec/slapd slapschema )
( cd usr/sbin ; rm -rf slaptest )
( cd usr/sbin ; ln -sf ../libexec/slapd slaptest )
( cd var/lib/run ; rm -rf ldapi )
( cd var/lib/run ; ln -sf ../../run/openldap/ldapi ldapi )
